
var gstate = 1;
var gch = 0;

window.addEventListener("load",function() {initAutoCopyStatus();} ,true);
window.addEventListener("focus",function() {resetAutoCopyStatus();} ,true);





function autocopyContextHide() {
	var cm = gContextMenu;
	var AutocopyFirebirdcontextmenuitem = document.getElementById('autocopy-firebirdcontextmenuitem');

	if(autocopyPrefs.getBoolPref("optContextMenuItem")){
	AutocopyFirebirdcontextmenuitem.hidden = ( cm.onImage || cm.onLink || cm.onTextInput );
	//|| cm.onLink || cm.onImage || cm.onTextInput );
	}
	else{
	    AutocopyFirebirdcontextmenuitem.hidden = true;
	}
}


function setAutoCopyStatus()
{
	var autocopy = document.getElementById('autocopy-status');
	var tooltip = document.getElementById('autocopy-tooltip-value');
	autocopy.setAttribute("status", enabled);
	tooltip.setAttribute("value", "Auto Copy Enabled");
}



function initAutoCopyStatus() 
{

        initPreferences();

	document.getElementById("contentAreaContextMenu").addEventListener("popupshowing",autocopyContextHide,false);
        
	var autocopyStatusBarButton = document.getElementById('autocopy-status');	
	var autocopyStatusBarButtonTooltip = document.getElementById('autocopy-tooltip-value');
	var Autocopyfirebirdkeytoggleautocopyenabled = document.getElementById('firebirdkey-toggle-autocopyenabled');
	var AutocopyFirebirdmenuitem = document.getElementById('autocopy-firebirdmenuitem');
	var AutocopyFirebirdmenuitemseparator = document.getElementById('autocopy-firebirdmenuitemseparator');
	var AutocopyFirebirdcontextmenuitem = document.getElementById('autocopy-firebirdcontextmenuitem');




        if(autocopyPrefs.getBoolPref("optStatusBar")){
            autocopyStatusBarButton.setAttribute("hidden", false);
        }
        else{
            autocopyStatusBarButton.setAttribute("hidden", true);
        }

        if(autocopyPrefs.getBoolPref("optEditMenuItem")){
	    AutocopyFirebirdmenuitemseparator.setAttribute("hidden", false);
            AutocopyFirebirdmenuitem.setAttribute("hidden", false);
        }
        else{
	    AutocopyFirebirdmenuitemseparator.setAttribute("hidden", true);
            AutocopyFirebirdmenuitem.setAttribute("hidden", true);
        }


        if(autocopyPrefs.getBoolPref("optKeyboardShortcutEnabled")){
    
            var optModifiers = "";
            if(autocopyPrefs.getBoolPref("optKeyboardShortcutKeyAccel"))
                optModifiers = optModifiers + ",accel";
            if(autocopyPrefs.getBoolPref("optKeyboardShortcutKeyMeta"))
                optModifiers = optModifiers + ",meta";
            if(autocopyPrefs.getBoolPref("optKeyboardShortcutKeyCtrl"))
                optModifiers = optModifiers + ",control";
            if(autocopyPrefs.getBoolPref("optKeyboardShortcutKeyShift"))
                optModifiers = optModifiers + ",shift";
            if(autocopyPrefs.getBoolPref("optKeyboardShortcutKeyAlt"))
                optModifiers = optModifiers + ",alt";
                
            optModifiers.replace(/^\,/,"");
        
            var optKey = autocopyPrefs.getCharPref("optKeyboardShortcutKey");
            if(optKey.match(/^[A-Z]$/i)){
                Autocopyfirebirdkeytoggleautocopyenabled.setAttribute("key", optKey);
                Autocopyfirebirdkeytoggleautocopyenabled.setAttribute("keycode", "");
            }
            else{
                Autocopyfirebirdkeytoggleautocopyenabled.setAttribute("key", "");
                Autocopyfirebirdkeytoggleautocopyenabled.setAttribute("keycode", optKey);
            }
            
            Autocopyfirebirdkeytoggleautocopyenabled.setAttribute("modifiers", optModifiers);
            Autocopyfirebirdkeytoggleautocopyenabled.setAttribute("disabled", false);
        }
        else{
            Autocopyfirebirdkeytoggleautocopyenabled.setAttribute("disabled", true);
        }

	if (gstate == 0)
        {
		 AutocopyFirebirdcontextmenuitem.setAttribute("checked", false);
                 AutocopyFirebirdmenuitem.setAttribute("checked", false);
                 autocopyStatusBarButton.setAttribute("status", "disabled");
                 autocopyStatusBarButtonTooltip.setAttribute("value", "Auto Copy Disabled");
        }
	else
	{
		 AutocopyFirebirdcontextmenuitem.setAttribute("checked", true);
                 AutocopyFirebirdmenuitem.setAttribute("checked", true);
                 autocopyStatusBarButton.setAttribute("status", "enabled");
                 autocopyStatusBarButtonTooltip.setAttribute("value", "Auto Copy Enabled");
	}
}



function resetAutoCopyStatus()
{
    initAutoCopyStatus()
}




function initPreferences(){

	if (!autocopyPrefs.prefHasUserValue("optStatusBar"))
		autocopyPrefs.setBoolPref("optStatusBar", true);
	if (!autocopyPrefs.prefHasUserValue("optEditMenuItem"))
		autocopyPrefs.setBoolPref("optEditMenuItem", true);
	if (!autocopyPrefs.prefHasUserValue("optContextMenuItem"))
		autocopyPrefs.setBoolPref("optContextMenuItem", true);
	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutEnabled"))
		autocopyPrefs.setBoolPref("optKeyboardShortcutEnabled", true);

	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutKeyAccel"))
		autocopyPrefs.setBoolPref("optKeyboardShortcutKeyAccel", false);
	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutKeyMeta"))
		autocopyPrefs.setBoolPref("optKeyboardShortcutKeyMeta", false);
	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutKeyCtrl"))
		autocopyPrefs.setBoolPref("optKeyboardShortcutKeyCtrl", true);
	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutKeyShift"))
		autocopyPrefs.setBoolPref("optKeyboardShortcutKeyShift", true);
	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutKeyAlt"))
		autocopyPrefs.setBoolPref("optKeyboardShortcutKeyAlt", false);
	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutKey"))
		autocopyPrefs.setCharPref("optKeyboardShortcutKey", "C");
}




function switchautocopystatusstate()
{
        if (gstate == 0)
        {
		autocopyPrefs.setIntPref("StatusBarState", 1);
                gstate = 1;
        }
        else
        {
		autocopyPrefs.setIntPref("StatusBarState", 0);
                gstate = 0;
        }
        initAutoCopyStatus();
}



// prefs
var autocopyPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("autocopy.");

if(!autocopyPrefs.prefHasUserValue("StatusBarState"))
{
	autocopyPrefs.setIntPref("StatusBarState", 1);
}

gstate = autocopyPrefs.getIntPref("StatusBarState");

window.onmouseup = TextSelected;
window.onkeyup = onKeyUpCheck;

function onKeyUpCheck(e)
{
	
	if(e.keyCode == e.DOM_VK_A && e.ctrlKey)
	{
		TextSelected(e);
	}
}


function TextSelected(e){
   if(gstate == 1){
       
        var targetclassname = e.target.toString();
        if (!targetclassname.match(/object XUL/i))
        {
            goDoCommand('cmd_copy');
        }
   }
}

